// This is Queue.h
//
// Copyright 1997, 1998        Mark Manca
//

#ifndef QUEUE_H
#define QUEUE_H

#include "DataStructures/LinkedList.h"


template <class Type>
class Queue : private LinkedList<Type> {
	public:
		inline Queue(Type& item);
		inline Queue();
		inline ~Queue();


		//
		// enqueue an element to the queue.
		//
		void enqueue(Type& item)                { appendItem(item); }


		//
		// dequeue an element from the queue.  If the queue is empty,
		// this function will return NULL.
		//
		inline Type dequeue(); 



		//
		// get the number of items that are in the queue
		//
		int getNumItemsInQueue()                { return getLength(); }



	protected:


	private:
};








template <class Type>
inline Queue<Type>::Queue(Type& item) 
	: LinkedList(item) {
	// empty
}


template <class Type>
inline Queue<Type>::Queue() { 
	// empty
}


template <class Type>
inline Queue<Type>::~Queue() {
	// empty
}




//
// dequeue an element from the queue.  If the queue is empty,
// this function will return NULL.
//
template <class Type>
inline Type Queue<Type>::dequeue() {
	Type item = getHead();
	removeHead();
	return item;
}





#endif         // QUEUE_H
