// This is Stack.h
//
// Copyright 1997, 1998        Mark Manca
//

#ifndef STACK_H
#define STACK_H

#include "DataStructures/LinkedList.h"


template <class Type>
class Stack : private LinkedList<Type> {
	public:
		inline Stack(Type& item);
		inline Stack();
		inline ~Stack();


		//
		// push an element onto the stack.
		//
		void push(Type& item)                   { appendItem(item); }


		//
		// pop an item off the stack. If the stack is empty, this function
		// will return NULL
		//
		inline Type pop(); 



		//
		// the getTop function will return the item that is on the top of
		// the stack without actually removing it from the stack.
		//
		Type getTop()                          { return getTail(); }


	protected:


	private:
};








template <class Type>
inline Stack<Type>::Stack(Type& item) 
	: LinkedList(item) {
	// empty
}


template <class Type>
inline Stack<Type>::Stack() { 
	// empty
}


template <class Type>
inline Stack<Type>::~Stack() {
	// empty
}




//
// pop an item from the stack. If there is nothing on the stack,
// this function will return NULL;
//
template <class Type>
inline Type Stack<Type>::pop() {
	Type item = getTail();
	removeTail();
	return item;
}





#endif         // STACK_H
