// This is ImageClear.C
//
// Copyright 1997, 1998     Mark Manca
//


#include "Image.h"


void Image::clear() {
	int i, j;


	//
	// duplicate a *LOT* of code to make operations go faster. Also, the large
	// amount of code duplication is necessary due to the different data types
	// that an image can be.
	//

	if (_imageDataType == GL_BYTE) {
		GLbyte *byteImagePtr = (GLbyte*)_imageData;

		if (_imageType == GL_COLOR_INDEX) {
			for (i=_height; i > 0; i--) {
				for (j=_width; j > 0; j--) {
					*byteImagePtr++ = 0;
				}
				byteImagePtr += _extraRowWidth;
			}
		}
		else if (_imageType == GL_RGB) {
			for (i=_height; i > 0; i--) {
				for (j=_width; j > 0; j--) {
					*byteImagePtr++ = 0;
					*byteImagePtr++ = 0;
					*byteImagePtr++ = 0;
				}
				byteImagePtr += _extraRowWidth;
			}
		}
		else {       // _imageType == GL_RGBA
			for (i=_height; i > 0; i--) {
				for (j=_width; j > 0; j--) {
					*byteImagePtr++ = 0;
					*byteImagePtr++ = 0;
					*byteImagePtr++ = 0;
					*byteImagePtr++ = 0;
				}
				byteImagePtr += _extraRowWidth;
			}
		}
	}
	else if (_imageDataType == GL_UNSIGNED_BYTE) {
		GLubyte *ubyteImagePtr = (GLubyte*)_imageData;
	
		if (_imageType == GL_COLOR_INDEX) {
			for (i=_height; i > 0; i--) {
				for (j=_width; j > 0; j--) {
					*ubyteImagePtr++ =  0;
				}
				ubyteImagePtr += _extraRowWidth;
			}
		}
		else if (_imageType == GL_RGB) {
			for (i=_height; i > 0; i--) {
				for (j=_width; j > 0; j--) {
					*ubyteImagePtr++ = 0;
					*ubyteImagePtr++ = 0;
					*ubyteImagePtr++ = 0;
				}
				ubyteImagePtr += _extraRowWidth;
			}
		}
		else {       // _imageType == GL_RGBA
			for (i=_height; i > 0; i--) {
				for (j=_width; j > 0; j--) {
					*ubyteImagePtr++ = 0; 
					*ubyteImagePtr++ = 0;
					*ubyteImagePtr++ = 0;
					*ubyteImagePtr++ = 0;
				}
				ubyteImagePtr += _extraRowWidth;
			}
		}
	}
	else if (_imageDataType == GL_SHORT) {
		GLshort *shortImagePtr = (GLshort*)_imageData;
		
		if (_imageType == GL_COLOR_INDEX) {
			for (i=_height; i > 0; i--) {
				for (j=_width; j > 0; j--) {
					*shortImagePtr++ = 0;
				}
				shortImagePtr += _extraRowWidth;
			}
		}
		else if (_imageType == GL_RGB) {
			for (i=_height; i > 0; i--) {
				for (j=_width; j > 0; j--) {
					*shortImagePtr++ = 0;
					*shortImagePtr++ = 0;
					*shortImagePtr++ = 0;
				}
				shortImagePtr += _extraRowWidth;
			}
		}
		else {       // _imageType == GL_RGBA
			for (i=_height; i > 0; i--) {
				for (j=_width; j > 0; j--) {
					*shortImagePtr++ = 0;
					*shortImagePtr++ = 0;
					*shortImagePtr++ = 0;
					*shortImagePtr++ = 0;
				}
				shortImagePtr += _extraRowWidth;
			}
		}
	}
	else if (_imageDataType == GL_UNSIGNED_SHORT) {
		GLushort *ushortImagePtr = (GLushort*)_imageData;
	
		if (_imageType == GL_COLOR_INDEX) {
			for (i=_height; i > 0; i--) {
				for (j=_width; j > 0; j--) {
					*ushortImagePtr++ = 0;
				}
				ushortImagePtr += _extraRowWidth;
			}
		}
		else if (_imageType == GL_RGB) {
			for (i=_height; i > 0; i--) {
				for (j=_width; j > 0; j--) {
					*ushortImagePtr++ = 0;
					*ushortImagePtr++ = 0;
					*ushortImagePtr++ = 0;
				}
				ushortImagePtr += _extraRowWidth;
			}
		}
		else {       // _imageType == GL_RGBA
			for (i=_height; i > 0; i--) {
				for (j=_width; j > 0; j--) {
					*ushortImagePtr++ = 0;
					*ushortImagePtr++ = 0;
					*ushortImagePtr++ = 0;
					*ushortImagePtr++ = 0;
				}
				ushortImagePtr += _extraRowWidth;
			}
		}
	}
	else if (_imageDataType == GL_INT) {
		GLint *intImagePtr = (GLint*)_imageData;
	
		if (_imageType == GL_COLOR_INDEX) {
			for (i=_height; i > 0; i--) {
				for (j=_width; j > 0; j--) {
					*intImagePtr++ = 0;
				}
				intImagePtr += _extraRowWidth;
			}
		}
		else if (_imageType == GL_RGB) {
			for (i=_height; i > 0; i--) {
				for (j=_width; j > 0; j--) {
					*intImagePtr++ = 0;
					*intImagePtr++ = 0;
					*intImagePtr++ = 0;
				}
				intImagePtr += _extraRowWidth;
			}
		}
		else {       // _imageType == GL_RGBA
			for (i=_height; i > 0; i--) {
				for (j=_width; j > 0; j--) {
					*intImagePtr++ = 0;
					*intImagePtr++ = 0;
					*intImagePtr++ = 0;
					*intImagePtr++ = 0;
				}
				intImagePtr += _extraRowWidth;
			}
		}
	}
	else if (_imageDataType == GL_UNSIGNED_INT) {
		GLuint *uintImagePtr = (GLuint*)_imageData;
	
		if (_imageType == GL_COLOR_INDEX) {
			for (i=_height; i > 0; i--) {
				for (j=_width; j > 0; j--) {
					*uintImagePtr++ = 0;
				}
				uintImagePtr += _extraRowWidth;
			}
		}
		else if (_imageType == GL_RGB) {
			for (i=_height; i > 0; i--) {
				for (j=_width; j > 0; j--) {
					*uintImagePtr++ = 0;
					*uintImagePtr++ = 0;
					*uintImagePtr++ = 0;
				}
				uintImagePtr += _extraRowWidth;
			}
		}
		else {       // _imageType == GL_RGBA
			for (i=_height; i > 0; i--) {
				for (j=_width; j > 0; j--) {
					*uintImagePtr++ = 0;
					*uintImagePtr++ = 0;
					*uintImagePtr++ = 0;
					*uintImagePtr++ = 0;
				}
				uintImagePtr += _extraRowWidth;
			}
		}
	}
	else {          // _imageDataType == GL_FLOAT
		GLfloat *floatImagePtr = (GLfloat*)_imageData;
	
		if (_imageType == GL_COLOR_INDEX) {
			for (i=_height; i > 0; i--) {
				for (j=_width; j > 0; j--) {
					*floatImagePtr++ = 0.0f;
				}
				floatImagePtr += _extraRowWidth;
			}
		}
		else if (_imageType == GL_RGB) {
			for (i=_height; i > 0; i--) {
				for (j=_width; j > 0; j--) {
					*floatImagePtr++ = 0.0f;
					*floatImagePtr++ = 0.0f;
					*floatImagePtr++ = 0.0f;
				}
				floatImagePtr += _extraRowWidth;
			}
		}
		else {       // _imageType == GL_RGBA
			for (i=_height; i > 0; i--) {
				for (j=_width; j > 0; j--) {
					*floatImagePtr++ = 0.0f;
					*floatImagePtr++ = 0.0f;
					*floatImagePtr++ = 0.0f;
					*floatImagePtr++ = 0.0f;
				}
				floatImagePtr += _extraRowWidth;
			}
		}
	}
}






