// This is bmpFileHeader.h
//
// Copyright 1997, 1998     Mark Manca
//


#ifndef BMPFILEHEADER_H
#define BMPFILEHEADER_H


struct bmpFileHeader {
	char fileType[2];          // specifies file type.  It must be 'BM'
	unsigned int sizeOfFile; 
	unsigned short reserved1;  // is reserved and must be 0 
	unsigned short reserved2;  // is reserved and must be 0
	unsigned int bitmapOffset; // offset in bytes of this structure to the bitmap bits
}; 
 



struct bmpInfoHeader {
	unsigned int sizeOfStruct; // size in bytes of the structure
	int width;                 // width of bitmap in pixels
	int height;                // height of bitmap in pixels
	unsigned short planes;     // num planes for target device.  Must be 1
	unsigned short bitsPerPixel;  // num bits per pixel.  Should be 1, 4, 8, 16, 24, or 32 
	unsigned int compression;  // type of compression for a compressed bottom-up bitmap
	unsigned int size;         // size in bytes of image.  May be 0 for rgb bitmaps
	int xPixelsPerMeter;       // x pix/meter of the target device for the bitmap
	int yPixelsPerMeter;       // y pix/meter of the target device for the bitmap
	unsigned int indicesUsed;  // the number of color table indices that are actually used
	unsigned int importantIndicies;   // the number of important indices for displaying bitmap
}; 




struct rgbQuad {
	unsigned char blue; 
	unsigned char green; 
	unsigned char red; 
	unsigned char reserved;    // must be 0
}; 



#endif     // BMPFILEHEADER_H