#ifndef _Intersect_h
#define _Intersect_h

#include "SceneIO.h"
#include "Raytrace.h"

/* intersection data structure */
typedef struct IsectType
{
  float t;
  ObjIO *object;
  int enter;

  float prevIndex;
  float nextIndex;

  Vector3f normal;
} Isect;

/* function prototypes */

int Intersect (Ray *ray, SceneIO *scene, Isect *I, RTParameters* g_params);
int SphereIntersect(Ray *ray, ObjIO *object, Isect *intersect, RTParameters* g_params);

void SphereNormal (ObjIO *object, Vector3f P, Vector3f N);

int PolysetIntersect (Ray *ray, ObjIO *object, Isect *intersect, RTParameters* g_params);
int TriangleIntersect (Ray *ray, PolygonIO *triangle, float *t_int, Vector3f normal,
					   RTParameters* g_params);

void SetIsect (Isect *I, float iT, ObjIO *iObject, int iEnter, float prevN, float nextN);
void CopyIsect (Isect *I1, Isect *I2);
void RayPoint (Ray *ray, float t, Vector3f P);
void ClampColor (Vector3f color);

#endif



