// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "RayTracer.h"
#include "TraceDialog.h"
#include "MainFrm.h"

#include "SceneView.h"
#include "TraceView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_COMMAND(ID_OPENSCENE, OnOpenscene)
	ON_COMMAND(ID_TRACESCENE, OnTracescene)
	ON_COMMAND(ID_TRACE_OPTIONS, OnTraceOptions)
	ON_COMMAND(ID_FILE_SAVE, OnFileSave)
	ON_COMMAND(ID_FILE_SAVEIMAGE, OnFileSaveimage)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	// TODO: add member initialization code here
	m_MaxDepth = 5;
	m_MinWeight = .05f;
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

	return 0;
}

BOOL CMainFrame::OnCreateClient( LPCREATESTRUCT /*lpcs*/,
	CCreateContext* pContext)
{
	RECT clientRect;
	GetClientRect( &clientRect );

	VERIFY( m_wndSplitter.CreateStatic( this, 1, 2 ) );
	VERIFY( m_wndSplitter.CreateView( 0, 1, RUNTIME_CLASS(CTraceView),
		CSize(clientRect.right/2,clientRect.bottom), pContext ) );
	VERIFY( m_wndSplitter.CreateView( 0, 0, RUNTIME_CLASS(CSceneView),
		CSize(clientRect.right/2,clientRect.bottom), pContext ) );
	return TRUE;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs
	cs.cx = 800;
	cs.cy = 400;

	return CFrameWnd::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers



void CMainFrame::OnOpenscene() {

	// TODO: Add your command handler code here
	CSceneView* mySceneView = ((CSceneView*)m_wndSplitter.GetPane(0,0));
	mySceneView->Openscene();

	int i=0;
}

void CMainFrame::OnTracescene() 
{
	// TODO: Add your command handler code here
	((CTraceView*)m_wndSplitter.GetPane(0,1))->RaytraceScene();
}

void CMainFrame::OnTraceOptions() 
{
	// TODO: Add your command handler code here
	CTraceDialog aDlg;

	// Display the Dialog as modal
	if(aDlg.DoModal() == IDOK)
	{
		m_MaxDepth = aDlg.m_MaxDepth;
	    m_MinWeight = (float)aDlg.m_MinWeight;

		CTraceView* myTraceView = ((CTraceView*)m_wndSplitter.GetPane(0,1));
	    myTraceView->SetDepthAndHeight(m_MaxDepth, (float) m_MinWeight / 100.0f);
	};

}

void CMainFrame::OnFileSave() 
{
	
}

void CMainFrame::OnFileSaveimage() 
{
	// TODO: Add your command handler code here
	// TODO: Add your command handler code here
	CFileDialog dlg( FALSE, "BMP", NULL, OFN_OVERWRITEPROMPT | OFN_HIDEREADONLY, "BMP files (*.bmp)|*.bmp|All Files (*.*)|*.*||", NULL );

	if ( dlg.DoModal() == IDOK )
	{
		CTraceView* myTraceView = ((CTraceView*)m_wndSplitter.GetPane(0,1));
	    myTraceView->FileSave(dlg.GetPathName());
	}	
}
