/***************************************************************************
 *
 * File:      Matrix4f.h
 *
 * Description: 
 *   Routines for 4x4 matrices of float 
 *
 ***************************************************************************/

#ifndef _Matrix4f_h_
#define _Matrix4f_h_

typedef float Matrix4f[16];

/* Computes out = m*v */
void Matrix4f_mult_Vector3f(float *m, float *v, float *out);

/* Sets m to the identity matrix. */
void Matrix4f_setidentity(float *m);

/* Sets the row numbered row of m to (v[0] v[1] v[2] 1) */
void Matrix4f_set_row(float *m, int row, float *v);

/* Sets the column numbered col of m to (v[0] v[1] v[2] 1) */
void Matrix4f_set_col(float *m, int col, float *v);

#endif /* _Matrix4f_h_ */
