// TraceDialog.cpp : implementation file
//

#include "stdafx.h"
#include "RayTracer.h"
#include "TraceDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTraceDialog dialog


CTraceDialog::CTraceDialog(CWnd* pParent /*=NULL*/)
	: CDialog(CTraceDialog::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTraceDialog)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	m_MaxDepth = 5;
	m_MinWeight = 5; 
}


void CTraceDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTraceDialog)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CTraceDialog, CDialog)
	//{{AFX_MSG_MAP(CTraceDialog)
	ON_WM_HSCROLL()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTraceDialog message handlers

BOOL CTraceDialog::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	//Get pointers to our sliders
	CSliderCtrl* pSliderDepth;
	pSliderDepth = (CSliderCtrl*)GetDlgItem(IDC_SLIDER1);

	CSliderCtrl* pSliderWeight;
	pSliderWeight = (CSliderCtrl*)GetDlgItem(IDC_SLIDER2);

	CString str;

	//Set up the range and the position
	pSliderDepth->SetRange(0,25,FALSE);
	pSliderWeight->SetRange(0,100,FALSE);
    
	pSliderDepth->SetPos(m_MaxDepth);
	pSliderWeight->SetPos(m_MinWeight);
	
	pSliderWeight->SetTicFreq(5);
	
	str.Format( "%d", m_MaxDepth );
	SetDlgItemText( IDC_STATIC_DEPTH, str );
	
	str.Format( "%d", m_MinWeight );
	SetDlgItemText( IDC_STATIC_WEIGHT, str );

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CTraceDialog::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	// TODO: Add your message handler code here and/or call default
	
	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
	
	CSliderCtrl* pSlider = (CSliderCtrl*) pScrollBar;
	CString str;

	switch( pScrollBar->GetDlgCtrlID() ) {

	case IDC_SLIDER1:
		m_MaxDepth = pSlider->GetPos();
		str.Format( "%d", m_MaxDepth );
		SetDlgItemText( IDC_STATIC_DEPTH, str );
		break;

	case IDC_SLIDER2:
		m_MinWeight = pSlider->GetPos();
		str.Format( "%d", m_MinWeight );
		SetDlgItemText( IDC_STATIC_WEIGHT, str );
		break;

	}

}
