#if !defined(AFX_TRACEVIEW_H__2AE963CF_CA77_11D1_87C0_00A0C9062F67__INCLUDED_)
#define AFX_TRACEVIEW_H__2AE963CF_CA77_11D1_87C0_00A0C9062F67__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

//Include the openGL header files.
#include "gl\gl.h"
#include "gl\glu.h"
#include "gl\glaux.h"
#include "SceneIO.h"
#include "Image/Image.h"
#include "Image/ImageFile.h"
#include "RenderPreview.h"
#include "Raytrace.h"

// TraceView.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CTraceView view

class CTraceView : public CView
{
protected:
	CTraceView();           // protected constructor used by dynamic creation
	DECLARE_DYNCREATE(CTraceView)

// Attributes
public:

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CTraceView)
	protected:
	virtual void OnDraw(CDC* pDC);      // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	//}}AFX_VIRTUAL

// Implementation
protected:
	virtual ~CTraceView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Generated message map functions
protected:
	//{{AFX_MSG(CTraceView)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnDestroy();
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

public:
	virtual BOOL SetupPixelFormat( void );
	virtual BOOL SetupViewport( int cx, int cy);
	virtual BOOL SetupViewingFrustum( GLdouble width, GLdouble height );
	virtual BOOL SetupViewingTransform( void );
	virtual BOOL RenderScene( void );
	virtual void StockScene ();
	void RenderScreen(SceneIO *scene, Image &image );
	void RaytraceScene();
	void SetDepthAndHeight(int depth, float weight);
	void FileSave(CString filename);
private:
	void SetError( int e );
	BOOL InitializeOpenGL();

	HGLRC m_hRC;
	CDC* m_pDC;

	static const char* const _ErrorStrings[];
	const char* m_ErrorString;
	int m_cx;		
	int m_cy;
	SceneIO* m_pScene;
	RTParameters m_RTparams;
	ImageFile raytraceImage;
	ImageFile imageToSave;
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_TRACEVIEW_H__2AE963CF_CA77_11D1_87C0_00A0C9062F67__INCLUDED_)
