
/* **************************************************************************
 *
 * File:      Vector3f.c
 *
 * Description:  
 *
 ************************************************************************** */


#include <math.h>

#include "Vector3f.h"


/* ************************************************************************* */



void Vector3f_copy(float *vin, float *vout) {
   vout[0] = vin[0];
   vout[1] = vin[1];
   vout[2] = vin[2];
}


void Vector3f_add(float *v1, float *v2, float *vout) {
   vout[0] = v1[0] + v2[0];
   vout[1] = v1[1] + v2[1];
   vout[2] = v1[2] + v2[2];
}



void Vector3f_sub(float *v1, float *v2, float *vout) {
   vout[0] = v1[0] - v2[0];
   vout[1] = v1[1] - v2[1];
   vout[2] = v1[2] - v2[2];
}



float Vector3f_length(float *v) {
   return (float)sqrt(v[0]*v[0] + v[1]*v[1] + v[2]*v[2]);
}




void Vector3f_normalize(float *v) {
   float len = Vector3f_length(v);

   v[0] /= len;
   v[1] /= len;
   v[2] /= len;
}



void Vector3f_scale(float s, float *v) {
   v[0] *= s;
   v[1] *= s;
   v[2] *= s;
}



void Vector3f_scale2(float s, float *in, float *out) {
   out[0] = s*in[0];
   out[1] = s*in[1];
   out[2] = s*in[2];
}



float Vector3f_dot(float *v1, float *v2) {
   return v1[0]*v2[0] + v1[1]*v2[1] + v1[2]*v2[2];
}



void Vector3f_set(float *v, float v1, float v2, float v3) {
   v[0] = v1;
   v[1] = v2;
   v[2] = v3;
}



void Vector3f_comp_mult(float *v1, float *v2, float *vout) {
  vout[0] = v1[0]*v2[0];
  vout[1] = v1[1]*v2[1];
  vout[2] = v1[2]*v2[2];
}


void Vector3f_cross(float *v1, float *v2, float *vout) {
   vout[0] = v1[1] * v2[2] - v1[2] * v2[1];
   vout[1] = v1[2] * v2[0] - v1[0] * v2[2];
   vout[2] = v1[0] * v2[1] - v1[1] * v2[0]; 
}

